import { LRParser, LocalTokenGroup } from '@lezer/lr';
import { styleTags, tags } from '@lezer/highlight';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageDescription, LanguageSupport } from '@codemirror/language';
import { MetaStore, TextDocument, getRainLanguageServices, CompletionItemKind, DiagnosticSeverity } from '@rainprotocol/rainlang';
export { MetaStore } from '@rainprotocol/rainlang';
import { Facet } from '@codemirror/state';
import { autocompletion } from '@codemirror/autocomplete';
import { hoverTooltip, ViewPlugin } from '@codemirror/view';
import { setDiagnostics } from '@codemirror/lint';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$zQzQPOOP!UOPOOO!ZQPO'#ClOOQO'#Ci'#CiO!bQPO'#ChOOQO'#C|'#C|OOQO'#Cr'#CrQYQPOOOOQO'#Cs'#CsQ!iQPOOOOQO'#Ct'#CtQ!nQPOOP!sOQO'#C]POOO)C>l)C>lO#OQPO,59WO#TQPO,59WOOQO,59S,59SO#[QPO,59SOOQO-E6p-E6pOOQO-E6q-E6qOOQO-E6r-E6rPOOO'#Cq'#CqP#cOQO,58wPOOO,58w,58wOOQO1G.r1G.rO#nQPO1G.rOOQO1G.n1G.nPOOO-E6o-E6oPOOO1G.c1G.cOOQO7+$^7+$^",
  stateData: "#w~OkOSlPQ~ORTOSTOTTOUTOVTOWTOXTOYTO^ROaQO~OcWOdYO~PYOl[O~Ob^O~PYOZ`O~PYOcWO~OdYO~OmeOneOogO~O_hO~ObiO~PYOZjO~PYOmeOneOolO~O_mO~O^aX~",
  goto: "#XqPrPPPPPPPPPPu}PP!VPPPP!_!e!s!yPPPPPPP#PR]P]TOQSV_a]SOQSV_a]ROQSV_aQf[RkfQVOQ_QQaSVbV_aQXORcXQZORdZ]UOQSV_a",
  nodeNames: "⚠ BlockComment Program Semi Comma Assignment AngleBracketOpen Number Placeholder VariableName Quote ParenClose Expression OpcodeOpening Opcode ParenOpen OpcodeWithOperandOpening OpcodeWithOperand AngleBracketClose Import Binding",
  maxTerm: 32,
  skippedNodes: [0,1,21],
  repeatNodeCount: 4,
  tokenData: ")]~RdXY!aYZ!a]^!apq!ast!rwx#sxy$tyz$y|}%O!P!Q%T!Q!R%`!R![&e![!]'X!]!^'^!^!_'c!`!a'h!b!c'm!c!}(e#R#S)W#T#o(e~!fSk~XY!aYZ!a]^!apq!a~!w[d~OX!rZ]!r^p!rqx!rz|!r}![!r!]!^!r!_!`!r!a#Q!r#R;'S!r;'S;=`#m<%lO!r~#pP;=`<%l!r~#x[Y~OX#sZ]#s^p#sqx#sz|#s}![#s!]!^#s!_!`#s!a#Q#s#R;'S#s;'S;=`$n<%lO#s~$qP;=`<%l#s~$yO_~~%OOZ~~%TOS~~%WPz{%Z~%`Ol~~%eQV~#U#V%k#l#m%y~%nP!Q!S%q~%vPV~!Q!S%q~%|R!Q![&V!c!i&V#T#Z&V~&[RV~!Q![&V!c!i&V#T#Z&V~&jQV~!Q![&p#X#Y&y~&sQ!Q![&p#X#Y&y~&|P!Q!['P~'UPV~!Q!['P~'^OT~~'cOR~~'hOU~~'mOb~~'pP!Q!R's~'vP#l#m'y~'|R!Q![(V!c!i(V#T#Z(V~([Rc~!Q![(V!c!i(V#T#Z(V~(jUX~xy(|}!O(e!Q![(e!^!_)R!c!}(e#T#o(e~)RO^~~)WOa~~)]OW~",
  tokenizers: [1, new LocalTokenGroup("u~RRYZ[]^az{i~aOn~~fPn~YZ[~lP!P!Qo~tOo~~", 36, 29)],
  topRules: {"Program":[0,2]},
  tokenPrec: 127
});

/**
 * @public Rainlang syntax highlighter
 */
const RainlangLR = LRLanguage.define({
    name: "rainlang",
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Expression: delimitedIndent({ closing: ")", align: false }),
            }),
            styleTags({
                Number: tags.number,
                Placeholder: tags.unit,
                VariableName: tags.variableName,
                Opcode: tags.keyword,
                OpcodeWithOperand: tags.keyword,
                BlockComment: tags.comment,
                AngleBracketOpen: tags.keyword,
                AngleBracketClose: tags.keyword,
                ParenOpen: tags.keyword,
                ParenClose: tags.keyword,
                Assignment: tags.separator,
                Comma: tags.punctuation,
                Semi: tags.punctuation,
                Import: tags.meta,
                Binding: tags.className,
                Quote: tags.string
            }),
            foldNodeProp.add({
                Expression: foldInside,
                BlockComment(tree) { return { from: tree.from + 2, to: tree.to - 2 }; }
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ["(", "<"] },
        commentTokens: { block: { open: "/*", close: "*/" } }
    }
});

// const useLast = (values: readonly any[]) => values.reduce((_, v) => v, '');
// const documentUri = Facet.define<string, string>({ combine: useLast });
// const languageId = Facet.define<string, string>({ combine: useLast });
/**
 * @public A plugin that manages languages services processes.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 */
class RainLanguageServicesPlugin {
    /**
     * @public constructor of the class
     * @param view - The editor view instance
     * @param metaStore - (optional) The meta store object to use
     */
    constructor(view, metaStore) {
        this.view = view;
        this.uri = "file:///untitled.rain";
        this.languageId = "rainlang";
        this.version = 0;
        this.metaStore = metaStore ? metaStore : new MetaStore();
        this.textDocument = TextDocument.create(this.uri, this.languageId, this.version, this.view.state.doc.toString());
        this.langServices = getRainLanguageServices({ metaStore: this.metaStore });
        this.processDiagnostics();
    }
    // update the instance of TexTdocument and RainDocument
    update(update) {
        if (!update.docChanged)
            return;
        else {
            TextDocument.update(this.textDocument, [{ text: this.view.state.doc.toString() }], ++this.version);
            this.processDiagnostics();
        }
    }
    destroy() { }
    /**
     * @public
     * Get the active meta store object of this plugin instance in order to manulay
     * update it for example update the meta store subgraphs or add a new k/v meta
     */
    getMetaStore() {
        return this.metaStore;
    }
    /**
     * @public Handles calls for hover tooltip
     */
    async handleHoverTooltip(view, position) {
        try {
            const hover = await this.langServices.doHover(this.textDocument, position);
            if (!hover)
                return null;
            else
                return getHoverTooltip(view.state.doc, hover, position);
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for code completion
     */
    async handleCompletion(context, position) {
        try {
            const completions = await this.langServices.doComplete(this.textDocument, position);
            if (!completions)
                return null;
            else
                return getCompletion(context, completions);
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for docuement diagnostics
     */
    async processDiagnostics() {
        try {
            this.view.dispatch(setDiagnostics(this.view.state, getDiagnostics(this.view.state.doc, await this.langServices.doValidation(this.textDocument))));
        }
        catch (err) {
            console.log(err);
            this.view.dispatch(setDiagnostics(this.view.state, []));
        }
    }
}
/**
 * @public Converts LSP hover to codemirror hover tooltips.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror Text object
 * @param hover - The LSP hover item
 * @param position - Position of the textDocument to get the completion items for
 * @returns Codemirror tooltip or null
 */
function getHoverTooltip(doc, hover, position) {
    const { contents, range } = hover;
    let pos = posToOffset(doc, position);
    let end;
    if (range) {
        pos = posToOffset(doc, range.start);
        end = posToOffset(doc, range.end);
    }
    if (pos === null)
        return null;
    const dom = document.createElement("div");
    dom.classList.add("documentation");
    //if (this.allowHTMLContent) dom.innerHTML = formatContents(contents);
    //else 
    dom.textContent = contents.value;
    return { pos, end, create: (_view) => ({ dom }), above: true };
}
/**
 * @public Converts LSP CompletionItem to codemirror code completions.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param context - Completion context
 * @param completionItems - The LSP completion items
 * @returns Codemirror completion result or null
 */
function getCompletion(context, completionItems) {
    const CompletionItemKindMap = Object.fromEntries(Object.entries(CompletionItemKind).map(([key, value]) => [value, key]));
    let { pos } = context;
    // const line = state.doc.lineAt(pos);
    // let trigKind: CompletionTriggerKind = CompletionTriggerKind.Invoked;
    // let trigChar: string | undefined;
    // if (
    //     !explicit &&
    //     plugin.client.capabilities?.completionProvider?.triggerCharacters?.includes(
    //         line.text[pos - line.from - 1]
    //     )
    // ) {
    //     trigKind = CompletionTriggerKind.TriggerCharacter;
    //     trigChar = line.text[pos - line.from - 1];
    // }
    if (
    // trigKind === CompletionTriggerKind.Invoked &&
    !context.matchBefore(/\w+$/))
        return null;
    let completions = completionItems.map(({ detail, label, kind, insertText, documentation, sortText, filterText, }) => {
        const completion = {
            label,
            detail,
            apply: (view, _comp) => {
                // re adjusting the cursor position for opcodes
                const matcher = prefixMatch([_comp]);
                const match = context.matchBefore(matcher[1]);
                if (insertText) {
                    let cursorPos = match.from + insertText.length - 1;
                    if (insertText.includes("<>"))
                        cursorPos -= 2;
                    view.dispatch({
                        changes: {
                            from: match.from,
                            to: match.to,
                            insert: insertText
                        },
                        selection: { anchor: cursorPos, head: cursorPos }
                    });
                }
                else
                    view.dispatch({
                        changes: {
                            from: match.from,
                            to: match.to,
                            insert: label
                        }
                    });
            },
            type: kind && CompletionItemKindMap[kind].toLowerCase(),
            sortText: sortText ?? label,
            filterText: filterText ?? label,
        };
        if (documentation) {
            completion.info = documentation.value;
        }
        return completion;
    });
    const [_span, _match] = prefixMatch(completions);
    const token = context.matchBefore(_match);
    if (token) {
        pos = token.from;
        const word = token.text.toLowerCase();
        if (/^\w+$/.test(word)) {
            completions = completions
                .filter(({ filterText }) => filterText.toLowerCase().startsWith(word))
                .sort(({ label: a }, { label: b }) => {
                switch (true) {
                    case a.startsWith(token.text) && !b.startsWith(token.text):
                        return -1;
                    case !a.startsWith(token.text) && b.startsWith(token.text):
                        return 1;
                }
                return 0;
            });
        }
    }
    return {
        from: pos,
        options: completions,
    };
}
/**
 * @public Converts LSP Diagnostics to codemirror diagnostics.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror Text object
 * @param diagnostics - The LSP Diagnostics
 */
function getDiagnostics(doc, diagnostics) {
    return diagnostics.map(({ range, message, severity }) => ({
        message,
        from: posToOffset(doc, range.start),
        to: posToOffset(doc, range.end),
        severity: {
            [DiagnosticSeverity.Error]: "error",
            [DiagnosticSeverity.Warning]: "warning",
            [DiagnosticSeverity.Information]: "info",
            [DiagnosticSeverity.Hint]: "info",
        }[severity]
    })).filter(({ from, to }) => from !== null &&
        to !== null &&
        from !== undefined &&
        to !== undefined).sort((a, b) => {
        switch (true) {
            case a.from < b.from:
                return -1;
            case a.from > b.from:
                return 1;
        }
        return 0;
    });
}
/**
 * @public Converts a position to offset of a character in a codemirror text.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param pos - The position to convert
 * @returns - The offset of the provided position
 */
function posToOffset(doc, pos) {
    if (pos.line >= doc.lines)
        return;
    const offset = doc.line(pos.line + 1).from + pos.character;
    if (offset > doc.length)
        return;
    return offset;
}
/**
 * @public Converts offset of a character in a codemirror text to a position.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param offset - The offset to convert
 * @returns - The position of the provided character offset
 */
function offsetToPos(doc, offset) {
    const line = doc.lineAt(offset);
    return {
        line: line.number - 1,
        character: offset - line.from,
    };
}
/**
 * @public Constructs regexp out of completion items.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param completions - Codemirror completion items
 * @returns Regexp of completion items
 */
function prefixMatch(completions) {
    function toSet(chars) {
        let preamble = "";
        let flat = Array.from(chars).join("");
        const words = /\w/.test(flat);
        if (words) {
            preamble += "\\w";
            flat = flat.replace(/\w/g, "");
        }
        return `[${preamble}${flat.replace(/[^\w\s]/g, "\\$&")}]`;
    }
    const first = new Set();
    const rest = new Set();
    for (const { label } of completions) {
        const [initial, ...restStr] = label;
        first.add(initial);
        for (const char of restStr) {
            rest.add(char);
        }
    }
    const source = toSet(first) + toSet(rest) + "*$";
    return [new RegExp("^" + source), new RegExp(source)];
}
/**
 * @public Reduces an array to its last element
 * @param values - Values to reduce
 */
const useLast = (values) => values.reduce((_, v) => v, "");

/**
 * @public The facet used to store and retrive RainLanguageServicesPlugin instance from a EditorView.plugin().
 * By getting the facet value from the state associated with that EditoreView instance, you then can intract
 * with the plugin directly to get the MetaStore instance and update its subgraph and metas manually, however,
 * this is not recommended as the meta storage and management is handled automatically by every meta hash that
 * is specified in an Rain document, so using this will not be needed in most of the cases unless some custom
 * behavior is intended.
 * This combination is provided for `rainlang` LanguageSupport class object and not for `RainlangExtention` class.
 *
 * @example
 * ```typescript
 * // get value of the facet
 * const rainViewPlugin = editorView.state.facet(RainLanguageServicesFacet);
 *
 * // get the plugin instance
 * const rainPlugin = editorView.plugin(rainViewPlugin);
 *
 * // update op meta from plugin
 * rainPlugin.getMetaStore();
 * ```
 */
const RainLanguageServicesFacet = Facet.define({ combine: useLast });
/**
 * @public Rainlang as a codemirror extension
 * @example
 * ```typescript
 * // instantiate the extension that can be directly used as codemirror extension
 * const rainlangExtension = new RainlangExtention(options);
 *
 * // instantiate the extension with initial meta data
 * const rainlangExtension = await RainlangExtension.create({services, subgraphs, metas})
 *
 * // to get the MetaStore instance of this extension instance
 * rainlangExtension.getMetaStore();
 * ```
 */
class RainlangExtension {
    /**
     * @public Constructor of the RainlangCodemirror class
     * @param config - Options for language services to include
     */
    constructor(config, metaStore) {
        this.extension = [];
        this.hover = hoverTooltip((view, pos) => this.plugin?.handleHoverTooltip(view, offsetToPos(view.state.doc, pos)) ?? null);
        this.completion = autocompletion({
            override: [
                async (context) => {
                    if (this.plugin == null)
                        return null;
                    return await this.plugin?.handleCompletion(context, offsetToPos(context.state.doc, context.pos));
                },
            ],
        });
        this.extension.push(RainlangLR, ViewPlugin.define(view => this.plugin = new RainLanguageServicesPlugin(view, metaStore)));
        if (!config)
            this.extension.push(this.hover, this.completion);
        else {
            if (config?.hover)
                this.extension.push(this.hover);
            if (config?.completion)
                this.extension.push(this.completion);
        }
    }
    /**
     * @public Creates the Rainlang extension with initial meta data (subgraphs and meta hash/bytes)
     * @param config - The configuration to create the extension with
     * @returns A promise that resolves with a RainlangExtension
     */
    static async create(config) {
        const metaStore = await MetaStore.create({
            subgraphs: config?.subgraphs,
            initMetas: config?.metas
        });
        return new RainlangExtension(config?.services, metaStore);
    }
    /**
     * @public Get the MetaStore object instance in order to manualy update its subgraphs or metas
     * Using this method is not recommended as meta management is handled completely automatically
     * from specified meta hashes in a Rain document and doesn't need any manual interference unless
     * some custom behavior is intended.
     */
    getMetaStore() {
        if (this.plugin)
            return this.plugin.getMetaStore();
    }
}
/**
 * @public
 * Provides Rainlang implementation for codemirror as LanguageSupport
 * This is the standard implementation of rainlang for codemirror.
 *
 * @example
 * ```typescript
 * const rainLanguageSupport = RainLanguage(config);
 * ```
 * in order to get the MetaStore instance, it should be done through getting the plugin instance
 * from the EditorView with providing it the result of getting the `RainLanguageServicesFacet`
 * facet and then calling `getMetaStore()` for it, however this is not recommended as meta management
 * is done automatically from specified meta hashes in a Rain document:
 * ```typescript
 * // get the `RainLanguageServicesFacet` value from editor view
 * const rainViewPlugin = view.state.facet(RainLanguageServicesFacet);
 *
 * // retrive the `RainLanguageServicesPlugin` instance
 * const rainPlugin = view.plugin(rainViewPlugin);
 *
 * // get the MetaStore instance
 * rainPlugin.getMetaStore()
 * ```
 *
 * @param config - Options for language services to include
 * @param metaStore - (optional) The meta store object to use
 * @returns rainlang LanguageSupport
 */
function RainLanguage(config, metaStore) {
    let plugin;
    const rainViewPlugin = ViewPlugin.define(view => plugin = new RainLanguageServicesPlugin(view, metaStore));
    const services = [];
    const hover = hoverTooltip((view, pos) => plugin?.handleHoverTooltip(view, offsetToPos(view.state.doc, pos)) ?? null);
    const completion = autocompletion({
        override: [
            async (context) => {
                if (plugin == null)
                    return null;
                return await plugin?.handleCompletion(context, offsetToPos(context.state.doc, context.pos));
            },
        ],
    });
    if (!config)
        services.push(hover, completion);
    else {
        if (config?.hover)
            services.push(hover);
        if (config?.completion)
            services.push(completion);
    }
    return new LanguageSupport(RainlangLR, [
        RainLanguageServicesFacet.of(rainViewPlugin),
        rainViewPlugin,
        ...services
    ]);
}
/**
 * @public Provides LanguageDescription class object for rainlang.
 * Use `load` to instantiate rain LanguageSupport with initial meta data
 */
const RainlangDescription = LanguageDescription.of({
    name: "rainlang",
    alias: ["Rain Language", "Rainlang", "RainLang", "rain"],
    extensions: [".rain", ".rainlang", ".rl"],
    load: async (config) => {
        const metaStore = await MetaStore.create({
            subgraphs: config?.subgraphs,
            initMetas: config?.metas
        });
        return Promise.resolve(RainLanguage(config?.services, metaStore));
    },
    support: RainLanguage()
});

export { RainLanguage, RainLanguageServicesFacet, RainLanguageServicesPlugin, RainlangDescription, RainlangExtension, RainlangLR, getCompletion, getDiagnostics, getHoverTooltip, offsetToPos, posToOffset, prefixMatch, useLast };
